
#define N 10
#define MAX 4

int a[N];
chan c = [0] { byte };

active proctype inssort() {
  int i, j, x;

  // Creates non-deterministic values (up to MAX) for a
  i = 0;
  do
  :: (i < N) -> j = 0;
     do
     :: (j < MAX) -> a[i] = j; j++;
     :: break
     od;
     i++;
  :: else -> break;
  od

  // Start the sort
  i = 1;
  do
  :: (i < N) -> x = a[i]; j = i;
     do
     :: (j > 0 && a[j - 1] > x) -> a[j] = a[j - 1]; j--;
     :: else -> break
     od;
     a[j] = x;
     c!i;
     i++;
  :: else -> break;
  od

term: skip;
  i = 0;
  do
  :: (i < N - 1) -> assert(a[i] <= a[i + 1]); i++;
  :: else -> break;
  od
}

active proctype monitor() {
  int counter, index;
  do
  :: c?index -> counter = 0;
     do
     :: (counter < index - 1) ->
          assert(a[counter] <= a[counter + 1]);
          counter++;
     :: else -> break;
     od
  od
}

ltl pa { <>inssort@term }





